/*
 *PeintureLum
 
 réaliser des dessins à la lampe de poche en live
 
 cdriko@free.fr
 
 Licence
 http://creativecommons.org/licenses/by-sa/2.0/fr/
 */
 
 

//import de la librairie GsVideo
import codeanticode.gsvideo.*;

//objet video
GSCapture video;
PImage masque;

color black = color(0);
int numPixels;

int tolerance;

void setup() {
  size(640, 480); // Change size to 320 x 240 if too slow at 640 x 480
  // Uses the default video input, see the reference if this causes an error
  video = new GSCapture(this, width, height);
  video.start();  
  masque= new PImage(width, height);
   numPixels = video.width * video.height;
  noStroke();
  smooth();
  background(0);
  video.mask(masque);//appliquer un masque à l'image video
  tolerance = 127; // Set the tolerance value
}

void draw() {
  if (video.available()) {
    video.read();
    
    ///creation du masque
    video.loadPixels();
    masque.loadPixels();
   
    float pixelBrightness; // Declare variable to store a pixel's color
    // Turn each pixel in the video frame black or white depending on its brightness
    loadPixels();
    for (int i = 0; i < numPixels; i++) {
      pixelBrightness = brightness(video.pixels[i]);
      if (pixelBrightness > tolerance) { // If the pixel is brighter than the
        masque.pixels[i] = video.pixels[i]; // tolerance value, make it white
      } 
      else { // Otherwise,
        masque.pixels[i] = black; // make it black
      }
    }
    updatePixels();
    
      video.mask(masque);
    
    tint(255, 255, 255, 150); 
   // blend(video, 0, 0, width, height, 0, 0, width, height, LIGHTEST);
    //blend(video, 0, 0, 33, 100, 67, 0, 33, 100, ADD);
  image(video,0,0);
    // Draw the webcam video onto the screen
  }
}

void mouseClicked() {
  
    background(0);///effacer l'écran
    
  
}

void keyPressed(){



switch(keyCode) {
  case 83: //S ou s
  print("sauvegarde de l'image...");
  saveFrame("data/capt-####.jpg");
   background(0);
   println("OK");
    break;
  case 38: //fleche du haut
  if(tolerance<255)tolerance++;
  println("tolerance="+tolerance);
    break;
    
    case 40://fleche du bas
    if(tolerance>0)tolerance--;
    println("tolerance="+tolerance);
    break;
  default:             // Default executes if the case labels
   println("touche inconnue:"+keyCode);   // don't match the switch parameter
    break;
}




}

